/*
  OMPi OpenMP Compiler
  == Copyright since 2001 the OMPi Team
  == Dept. of Computer Science & Engineering, University of Ioannina

  This file is part of OMPi.

  OMPi is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  OMPi is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with OMPi; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "e_lib.h"
#include "shared_data.h"
#include "device_globals.h"

#ifdef LOCK_TASK_QUEUE

/* How = 0 (wait for my children), 1 (wait for all team tasks),
 *       2 (wait at the end of parallel)
 */
int ort_taskwait(int how)
{
	/* Synchronize with other threads */
#ifdef OLD_BAR
	if (how == 0)
		ort_execute_tasks(__MYCB, 0);
	else
		return barrier();
#else
	if (how == 0)
		ort_execute_tasks(__MYCB, 0);
	else
		return e_my_barrier();
#endif

	return 0;
}

#else

/* How = 0 (wait for my children), 1 (wait for all team tasks),
 *       2 (wait at the end of parallel)
 */
int ort_taskwait(int how)
{
	/* Synchronize with other threads */
#ifdef OLD_BAR
	if (how != 0)
		return barrier();
#else
	if (how != 0)
		return e_my_barrier();
#endif

	return 0;
}

#endif
